/**
 * This class contains all the necessary functions to deal with the tabs section of the UI.
 * Its init() function should be called immediately upon successful project load.
 */
function AllTabs() {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var gen = new GenericTab();
    
    // PRIVATE FUNCTIONS \\     function privateFunction(){}
    this.scene = new SceneTab(gen);
    this.stats = new StatsTab(gen);
    this.status = new StatusTab(gen);
    this.inventory = new InventoryTab(gen);
    this.save = new SaveTab(gen);
    this.load = new LoadTab(gen);

    // PUBLIC MEMBERS \\        this.public = "test";

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Initializes all tabs.
     */
    this.init = function () {
        that.scene.init();
        that.stats.init();
        that.status.init();
        that.inventory.init();
        that.save.init();
        that.load.init();
    };
}
