/**
 * Hide section of the woods.
 * @param {ForestController} controller The Forest controller.
 */
function ForestWoodsHideSurrenderSpank(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = new ForestWoodsHideSurrenderSpankContinue(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var pants = ctrl.misc.pants();
        // CAN NOT reach this part via treeFail, because treeFail implies rock or stick.
        var toReturn = `[p]
                            Game over.
                            They've got you trapped.
                            You [i]could[/i] run, but you doubt you'd be able to get away.
                            If you hadn't squandered away your time by trying to hide, perhaps you'd have stood a chance. 
                            As things are now, your best bet would be to [i]surrender[/i] yourself to them, and [b]hope[/b] they go easy on you.
                        [/p]
                        [p]
                            You emerge from the bush, and pre-emptively remove the bag of gold from around your neck.
                            Staring at it longingly, you let out a loud sigh.
                            If only you'd been a little [i]smarter[/i], you wouldn't have had to part with your one chance at paying your debts.
                            But alas, what's done is done.
                            In some weird way, this is the [b]right[/b] thing to do.
                            You swallow deeply, and mentally prepare yourself for whatever judgement your pursuers may render unto you.
                        [/p]
                        [p]
                            The party comes into view.
                            A big, buff anthromorphic wolf and a human, with a leashed feral dog that barks its lungs out at you.
                            They seem surprised to see you standing here, coinpouch in hand.
                            The human calms his loud pet, threatening to [b]hit it[/b] to make it [b]shut up[/b].
                            Then, the wolf steps towards you.
                        [/p]
                        [p]
                            The broad lupine leans down to bring his head to your level, glaring at you with hate-filled eyes, his large fangs bared.
                            You shiver in fear, frozen in place.
                            Without a word, the man takes the pouch from your hand, bouncing it up and down, as if [i]checking[/i] the weight.
                            Then, finally, he breaks the tense silence.
                            "[color=gblue]So you're our [i]little[/i] [b]thief[/b], huh?[/color]"
                            You barely manage to [b]nod[/b] in response, too scared to speak.
                            "[color=gblue]Did you really think you could [b]steal[/b] from the [b]baron[/b] and get away with it?[/color]"
                            You shake your head no, and stammer out a meek apology.
                        [/p]
                        [p]
                            "[color=gblue]I've [b]eaten[/b] lizards bigger than you.[/color]"
                            The wolf licks his lips, as though salivating at the thought.
                            "[color=gblue]But then again, I've also raised four pups of my own,
                            and one of them is a [b]thieving little shit[/b] just like you.[/color]"
                            The canine tosses the gold pouch to his human accomplice, hitting his mark without even needing to look back.
                        [/p]
                        [p]
                            "[color=gblue]Normally, me and Kajar would cut you up into [b]minced meat[/b] and feed you to Rex for what you did.
                            Rex is the dog, mind you.[/color]"
                            The pooch barks upon hearing its name.
                            "[color=gblue]But since you [b]presented[/b] yourself to us on a [b]silver platter[/b],
                            like a little [b]cub[/b] that [b]knows[/b] it [b]fucked up bigtime[/b], I'll go easy on you.[/color]"
                            A broad grin forms on the wolf's face.
                            "[color=gblue]After all, I know how to handle [b]brats[/b] like none other.[/color]"
                        [/p]
                        [p]
                            The wolf straightens his back once more, towering over you like a mountain over a valley.
                            Grabbing you by the scruff with his powerful hand, he outright [b]drags[/b] you with him as he walks towards a nearby felled tree.
                            You do little to resist, knowing fully well that the lupine could [b]snap your neck[/b] with ease if he wanted to.
                            You begin to fear the worst, however, as the strong canine forcibly [b]bends[/b] you over the horizontal
                            trunk${pants ? `. Your fear deepens as your ${global.kobold.inventory.createItemWithTooltip(pants)} get crudely lowered` : ``}, your
                            bare behind on display for the entire forest to see.
                        [/p]
                        [p]
                            Panic settles in as you think the wolf is about to [b]rape[/b] you.
                            What about all that talk about his children?!
                            Surely he doesn't do [i]that[/i] to them, right?!
                            Luckily, the lupine doesn't step behind you, instead ominously standing right next to you, a sadistic smirk plastered across his face.
                            What, is he going to let the [b]human[/b] have a go?
                            Or maybe the [b]dog[/b]?!
                        [/p]
                        [p]
                            You begin to struggle against the canine's unrelenting grasp, your mind coming up with [b]worse[/b] and [b]worse[/b] scenarios.
                            Ignoring your feeble resistance, the strong guard lifts one of his big, buff arms high up in the air,
                            before swinging it downwards at a high velocity, the flat palm of his furred hand [b]smacking[/b] heavily against your scaly rear.
                            You yelp out in surprise, stinging pain spreading forth from your slightly jiggling buttcheeks.
                            He's...[b]spanking[/b] you?!
                        [/p]
                        [p]
                            True to his word, the wolf treats you like nothing but a [b]child[/b].
                            He raises his hand once more, striking your rear a second time, and a third, and a fourth, pain mounting with every hit.
                            You [b]beg[/b] for him to stop, tears forming at the corners of your eyes, but there is no mercy to be found here.
                            The sound of the human laughing out loud at the display before him,
                            the rhythmic slapping of flesh against scales,
                            and your miserable cries for mercy reverberate across the woods,
                            your utter [b]humiliation[/b] broadcasted far beyond the eyes of your abusers.
                        [/p]
                        [p]
                            A few minutes of the demeaning treatment later, you are reduced to a pathetic, crying [b]mess[/b] of a would-be-thief.
                            One final time, the wolf's firm hand smacks against your fiery-red bottom, drawing one more pitiful whimper from your lips.
                            Finally, he is done.
                            Grabbing you by the scruff once more, he pulls you from the log, and tosses you to the ground,
                            forcing you to [b]sit[/b] on your tenderized behind, knowing fully well you have nobody but [b]yourself[/b] to blame for all of this.
                        [/p]
                        [p]
                            "[color=gblue]Think about what you've done. There [b]won't[/b] be a next time, got it?[/color]"
                            You wipe away your still-flowing tears, and meekly nod your head.
                            "[color=gblue]Good. Here's something to remember us by.[/color]"
                            The wolf signals to his comrade.
                            The human, in turn, tosses the emptied coin pouch back at you, as if to serve as a reminder of what happened here today.
                            After exchanging glances and nodding at one another, the two men and their pet leave without a word.
                            They got what they came for, and you got what you deserved.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = ctrl.preContinue.continued() ? "disabled" : "";
        var isSelected = ctrl.preContinue.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            ctrl.preContinue.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += ctrl.surrenderSpank.change();
        part += buildChoice();
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        next.registerListeners();

        if (ctrl.preContinue.continued()) {
            return;
        }

        registerNextListener();
    };
}
