/**
 * The second part of the introduction of the Forest scene.
 * @param {ForestController} controller The forest controller.
 * @param {ForestIntroductionPathSelection} nextPart The next part to load once finished.
 */
function ForestIntroductionItemSelection(controller, nextPart) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;
    var next = nextPart;

    var rockId = "introRock";
    var branchId = "introBranch";
    var neitherId = "introNeither";

    var contentStart = `<div class="text">
                            You take some deep breaths.
                            You calm down a little.
                            Your close your eyes. `;
    var past = `            Your mind wanders to your past.
                            A couple of years ago, you were in a similar situation as the one you find yourself in today.
                            Not quite as severe, but somewhat of the same nature.
                        </div>
                        <div class="text">
                            You couldn't pay your monthly fee.
                            You were terrified. 
                            Scared shitless of what might happen without the <span class="italic">protection</span> of the <span class="bold">Three-Tailed Rat Clan</span>.
                            The day the money was due, you marched into town with your tail between your legs.
                            You were granted an audience with the Rat's second-in-command.
                            You grovelled, you begged and you reluctantly humiliated yourself in front of him.
                        </div>
                        <div class="text">
                            Eventually, after humoring the kobold with your <span class="italic">patheticness</span> for the better half of an hour, 
                            he tentatively accepted <span class="bold">your failure</span> to provide the Rat with his <span class="bold">just due</span>.
                            You were let off the hook with a slap on the wrists, a thoroughly dented sense of self-esteem, and a twenty percent interest rate.
                        </div>
                        <div class="text">
                            You owe far more than fifty coins this time around, 
                            the Rat himself is personally involved in the matter, 
                            <span class="bold">and</span> you won't be able to make it to the city before your deadline expires,
                            but perhaps it might still be in your best interest to visit the gang's headquarters as soon as possible.
                            After all, you've just acquired an entire pouch filled with gold.
                            Surely that will be enough to at least buy you some time, right?
                        </div>`;
    var present = `         Your mind wanders to the men you stole from.
                            You had a chance to inspect them before making your move.
                            There was definitely something odd about them, but you can't quite put your finger on it.
                        </div>
                        <div class="text">
                            It was clear the caravan was an imperial money transport, all the animals branded with the seal of the king himself.
                            Probably taxes or something.
                            The footmen, however, looked <span class="bold">nothing</span> like <span class="bold">any</span> of the soldiers or guards you'd ever seen before.
                            Instead of a proper, well-maintained combat cuirass, many of them wore leather armor.
                            Only the overseer wore a distinctive imperial tunic.
                            Heck, some of them were clothed in not much more than the scraggy rags you're wearing.
                        </div>
                        <div class="text">
                            Their attitude, too, was very unbecoming of the king's finest.
                            A few of them were openly guzzling booze from animal-leather drinking pouches.
                            At least you assume it was some kind of alcoholic beverage, because no healthy man should wobble on his feet as he lazily walks alongside a slow-moving cart.
                        </div>
                        <div class="text">
                            While the drunkards were somewhat pacified from the inebriating brews they drank, the rest seemed like a rowdy bunch.
                            They were constantly either laughing at some crude joke, punching eachother's arms or measuring weapon sizes against one another.
                            When one of them spotted a feral brown bear scurrying off into the forest just to <span class="bold">avoid</span> the unpleasant group, 
                            the burly man instantly let out a rallying cry, and in the flash of an eye they all began to chase after it like a bunch of dimwits, their weapons drawn.
                        </div>
                        <div class="text">
                            If you didn't know any better, you'd almost come to think these men were brigands themselves.
                            But why would a bunch of bandits be escorting the king's gold?
                            It doesn't make any sense to you.
                            They couldn't have been keeping the caravan master hostage.
                            He'd have ran away the moment they turned their backs.
                            Nor could they have been guiding the gold elsewhere. The road they were on led to Varanar, and nowhere <span class="bold">but</span> Varanar.
                        </div>
                        <div class="text">
                            You decide not to break your head over this conundrum.
                            The one thing you can make from all of this, is that you should be extra careful around those guys.
                            While you're unsure whether or not they even <span class="bold">noticed</span> the missing bag, one of them <span class="italic">might</span> have seen you slip away from the caravan.
                            They might decide to <span class="italic">hunt</span> you, much like they did the bear.
                            And should these men manage to catch you, you sincerely doubt they'll punish your crime of theft according to law.
                        </div>`;
    var future = `          You turn your mind to your future, which looks a lot brighter now than it did just an hour ago.
                            Depending on the exact contents of the pouch around your neck, you may have bailed yourself out of trouble completely.
                        </div>
                        <div class="text">
                            You've never actually <span class="italic">had</span> more than a hundred coins on you at any given time, 
                            so you can't quite make out how much money this is by its weight alone.
                            Still, unless the bag is weighed down with rocks or something, it's bound to be <span class="bold">a lot</span>.
                            You'll count it properly once you've regained your composure.
                        </div>
                        <div class="text">
                            You need a few more moments to calm down further.
                            That's what you tell yourself, at least.
                            The truth is that you want to dream a bit more, to forget all about the harsh reality of things for a minute longer.
                            You imagine yourself proudly marching home, awaiting the debt collector the Rat has undoubtebly sent your way and
                            handing him whatever you owe with a shit-eating grin on your face, plus a little extra for himself, of course.
                        </div>
                        <div class="text">
                            Then, you'll take the rest of the coin to Varanar, 
                            treat yourself to the <span class="bold">biggest</span>, <span class="bold">juiciest</span> piece of meat you can find
                            and sleep at the most luxurious inn in town.
                            You can practically feel the warm blankets surrounding you, and taste the succulent steak served by a couple of scantily-clad vixens.
                            That is, until all too soon, the doubt and concern growing at the back of your head put a rapid end to your daydream.
                            You snap back to reality.
                        </div>`;

    var contentEnd = `  <div class="text">
                            Your breath stabilizes.
                            You slowly open your eyes once more.
                            You wipe the sweat from your brow.
                            You have calmed down from your hyperventilation, hysteria and near-panic.
                            Your legs are feeling a little better.
                            You wearily pull yourself to your feet.
                        </div>
                        <div class="text">
                            As you take a few moments to compose yourself further, a second wave of worry washes over you.
                            You are weak, almost to the point of being defenceless, and you have a large amount of money visibly strapped around your neck.
                            You present the perfect opportunity for any would-be bandit you cross to get a fat payday without having to put in all that much effort.
                            You need a weapon. 
                            Something to protect yourself with. 
                            You scrounge through some nearby bushes, and come up with two suitable candidates.
                        </div>`;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds the past part of the item selection.
     * @returns {string} The past part of the item selection.
     */
    function buildPast() {
        return past;
    }

    /**
     * Builds the present part of the item selection.
     * @returns {string} The present part of the item selection.
     */
    function buildPresent() {
        return present;
    }

    /**
     * Builds the future part of the item selection.
     * @returns {string} The future part of the item selection.
     */
    function buildFuture() {
        return future;
    }

    /**
     * Builds and returns the main content of this section.
     * @returns {string} The main content of this section.
     */
    function buildContent() {
        var content = contentStart;
        var previousChoice = ctrl.intro.getThinkingChoice();
        if (previousChoice == ForestIntroductionThinkingChoiceEnum.PAST) {
            content += buildPast();
        }
        if (previousChoice == ForestIntroductionThinkingChoiceEnum.PRESENT) {
            content += buildPresent();
        }
        if (previousChoice == ForestIntroductionThinkingChoiceEnum.FUTURE) {
            content += buildFuture();
        }
        content += contentEnd;
        return content;
    }

    /**
     * Builds and returns the neither choice button.
     */
    function buildRockChoice() {
        var disabled = ctrl.intro.hasMadeItemChoice() ? "disabled" : "";
        var isSelected = ctrl.intro.getItemChoice() == ItemEnum.ROCK;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${rockId}" ${disabled}>A rock</button>`;

        var popupContainer = global.kobold.inventory.createItemTooltip(button, new Rock());
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;
        
        return button;
    }

    /**
     * Builds and returns the branch choice button.
     */
    function buildBranchChoice() {
        var disabled = ctrl.intro.hasMadeItemChoice() ? "disabled" : "";
        var isSelected = ctrl.intro.getItemChoice() == ItemEnum.BRANCH;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${branchId}" ${disabled}>A branch</button>`;

        var popupContainer = global.kobold.inventory.createItemTooltip(button, new Branch());
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the neither choice button.
     */
    function buildNeitherChoice() {
        var disabled = ctrl.intro.hasMadeItemChoice() ? "disabled" : "";        
        var isSelected = ctrl.intro.getItemChoice() === 0;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${neitherId}" ${disabled}>Neither</button>`;
        
        var popupContainer = global.ui.makeToolTip(button, `You don't need any weapons. They'd just slow you down. You're dead meat if you get into a fight either way.`);
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;
        
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer"><div class="inlinechoiceheader">You take:</div>`;
        choice += buildRockChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildBranchChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildNeitherChoice();
        choice += `</div>`;
        return choice;
    }
    
    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + rockId), $("#" + branchId), $("#" + neitherId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }
    
    /**
     * Loads and displays the next part.
     */
    function loadNextPart() {
        var part = next.build(true);
        global.ui.appendBeforeFinisher(part, global.ui.genericHeaderId);
        $("#" + next.id).fadeIn(400);
        next.registerListeners();
    }
    
    /**
     * Adds a listener to the rock button.
     */
    function registerRockListener() {
        $("#" + rockId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            ctrl.intro.makeItemChoice(ItemEnum.ROCK);
            loadNextPart();
        });
    }
    
    /**
     * Adds a listener to the branch button.
     */
    function registerBranchListener() {
        $("#" + branchId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            ctrl.intro.makeItemChoice(ItemEnum.BRANCH);
            loadNextPart();
        });
    }
    
    /**
     * Adds a listener to the neither button.
     */
    function registerNeitherListener() {
        $("#" + neitherId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            ctrl.intro.makeItemChoice(0);
            loadNextPart();
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = "introductionItem";

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (!ctrl.intro.hasMadeThinkingChoice()) {
            return "";
        }
        ctrl.intro.itemShared();
        var change = ctrl.intro.itemSelectionStatusChange();
        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += change;
        part += buildChoice();
        part += `</div>`;
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (!ctrl.intro.hasMadeThinkingChoice()) {
            return;
        }
        if (ctrl.intro.hasMadeItemChoice()) {
            return;
        }
        registerRockListener();
        registerBranchListener();
        registerNeitherListener();
    };
}
